#ifndef FE_COORD_H
#define FE_COORD_H

/* FE_position:
   notion de point dans l'espace simple */
typedef struct FE_position FE_position;
struct FE_position
{int x,y,z;};

/* FE_point:
   notion de point dans l'espace destiné à etre utilisé dans l'affichage
   Dépend de
      "coord.h"
	     FE_position */
typedef struct FE_point FE_point;
struct FE_point
{FE_position real,translated,rotated};

#include "FxEngine.h"

/* FE_calc():
   applique la matrice de rotation sur les coordonnées d'un point
   
   Dépend de :
      "coord.h"
	     FE_cos()
		 FE_sin()
         FE_point */
void FE_calc(FE_point* point);

/* FE_set_matrice():
   change la matrice de rotation pour le cycle à venir
   
   Dépend de :
      "coord.h"
	     FE_cos()
		 FE_sin() */
void FE_set_matrice(void);



/* constantes mathématiques */
extern const double FE_PI, FE_2_PI, FE_PI_SUR_2;

/* FE_modulo_2pi():
   ramener la mesure d'un angle orienté à la valeur comprise entre 0 et 2 pi */
double FE_modulo_2pi(double a);

/* FE_cos():
   implémentation du cosinus */
double FE_cos(double angle);
/* FE_sin():
   implémentation du sinus 
   
   Dépend de :
      "coord.h"
	     FE_cos() */
double FE_sin(const double angle);


#endif
