#ifndef FE_ZBUFFER
#define FE_ZBUFFER

/** Taille du z_buffer **/
#define FE_ZB_SIZE_X 128
#define FE_ZB_SIZE_Y 64

/** FE_zbuffer_clear 
 * effacer le z buffer pour un nouveau cycle de dessin
 * TODO : ajouter effacement avec le DMA Controller pour les modèles ayant un processeur SH4-A
**/
void FE_zbuffer_clear();

#include <stdbool.h>
#include <stdint.h>
/** FE_zbuffer_set_dist 
 * change la distance d'un pixel du zbuffer
 * retourne true si il faut dessiner le pixel
 * retourne false si le pixel est déjà existant
**/
bool FE_zbuffer_set_dist(int32_t x, int32_t y, int32_t dist); // if you are allowed to draw the pixel on vram

#endif
